#property  copyright "2010 Kjell Hasthi"
#property  link      "kjell.hasthi@hotmail.com"

#property  indicator_separate_window
#property  indicator_buffers 2
#property  indicator_color1  LimeGreen
#property  indicator_color2  FireBrick 

extern int NumberOfBars1 = 11;
extern int NumberOfBars2 = 5;
extern bool ShowAlert = true;
extern int AlertCount = 100;

//---- indicator buffers
double UpBuffer[];
double DownBuffer[];

int init()
{
   IndicatorBuffers(2);
   SetIndexStyle(0,DRAW_HISTOGRAM,STYLE_SOLID,4);
   SetIndexStyle(1,DRAW_HISTOGRAM,STYLE_SOLID,4);

   IndicatorDigits(MarketInfo(Symbol(),MODE_DIGITS)+2);

   SetIndexBuffer(0,UpBuffer);
   SetIndexBuffer(1,DownBuffer);

   IndicatorShortName("Trend Strength("+NumberOfBars1+","+NumberOfBars2+")" );
   return(0);
}
//+------------------------------------------------------------------+
//| Trend Strength                                                |
//+------------------------------------------------------------------+
int start()
{
   double t, diff1,diff2;
   int nLimit, i;
   int nCountedBars;
   int ShiftDif;
   
         
   nCountedBars = IndicatorCounted();
//---- check for possible errors
   if(nCountedBars<0) 
      return(-1);
//---- last counted bar will be recounted
   if(nCountedBars>0) 
      nCountedBars--;
   nLimit = Bars-nCountedBars;

   static int count = 0;
   
   for(i=0; i<50000; i++)
   {
      double Ema3=iMA(NULL,0,3,0,MODE_EMA,PRICE_CLOSE,i);
      double UpperBollBand1=iBands(NULL,0,NumberOfBars1,1,0,PRICE_CLOSE,MODE_UPPER,i);
      double LowerBollBand1=iBands(NULL,0,NumberOfBars1,1,0,PRICE_CLOSE,MODE_LOWER,i);

      double Ema2=iMA(NULL,0,2,0,MODE_EMA,PRICE_CLOSE,i);
      double UpperBollBand2=iBands(NULL,0,NumberOfBars2,1,0,PRICE_CLOSE,MODE_UPPER,i);
      double LowerBollBand2=iBands(NULL,0,NumberOfBars2,1,0,PRICE_CLOSE,MODE_LOWER,i);
                   
      diff1 = 0.0;
      diff2 = 0.0;      

      if (Ema3-UpperBollBand1 > 0)
            diff1=Ema3-UpperBollBand1;
      if (Ema2-UpperBollBand2 > 0)
            diff2=Ema2-UpperBollBand2;
      UpBuffer[i] = MathMax( diff1, diff2);      

      if (ShowAlert && i==0 && UpBuffer[i] > 0 && UpBuffer[i+1] == 0)
      {
            if (count==AlertCount/2) 
              Alert( "Uptrend on " + Symbol());
      }

      diff1 = 0.0;
      diff2 = 0.0;      

      if (Ema3-LowerBollBand1 < 0)
            diff1=Ema3-LowerBollBand1;
      if (Ema2-LowerBollBand2 < 0)
            diff2=Ema2-LowerBollBand2;
      DownBuffer[i] = MathMin( diff1, diff2);      
      if (ShowAlert && i==0 && DownBuffer[i] < 0 && DownBuffer[i+1] == 0)
      {
            if (count==AlertCount/2) 
              Alert( "Downtrend on " + Symbol());
      }
      if (count > AlertCount) count = 0;
      if (i==0) count = count + 1;
   }

   return(0);
  }

